import { Lookup } from 'geoip-lite';
import { Details } from 'express-useragent';
import { AuditAction } from './audit.enum';
import { AuditLog } from './audit.entity';

export interface UserLoginEntry {
  login_at: Date;
  current: boolean;
  location: Partial<Lookup>;
  user_agent: Partial<Details>;
}

export interface AuditSearchClause {
  actions?: AuditAction[] | string;
  user?: string;
  ip?: string;
  ua?: string;
  content?: string;
  flagged?: boolean;
}

export interface AuditResponse extends AuditLog {
  location?: Partial<Lookup>;
  user_agent?: Partial<Details>;
}
